# Paragraphs

Paragraphs describe text that you want to put on screen.

They look like this:

```
StringType: Paragraph(
    font_family: "Fira Code",
    value: "new String()",
    language: "java",
)
```

(It's worth noting that strings can have newlines. Every character inside of the quotes except for the quotes themselves are acceptable inside a string. Quotes can be escaped with `\"`)

These are the key-value pairs that are valid for Paragraphs

- `value`: The text you want to put inside the object. Text is compatible with the [djot](https://djot.net/) markup syntax. The text will be wrapped to the size of the viewbox it's in, and adjust if it's moved to a different sized viewbox. The formatter will automatically change instances of `value` to `code` if a `language` is present in the object.
- `align`: If the text is wrapped, or the text is multiple lines, this is how the new lines of text will be aligned. Can be one of

  - `left`
  - `center`
  - `right`
  - `justified`
  - `end`

  These are based on [cosmic-text's `Aligns`](https://docs.rs/cosmic-text/0.12.1/cosmic_text/enum.Align.html)

- `vertical_spacing`: Can be one of

  - `normal`
  - `even`

- `font_family`: The font that you want to use for the text. If you're using the LSP, you should get autocomplete for this parameter. This must be a font on your computer or one of the following

  - `serif`
  - `sans-serif`
  - `cursive`
  - `fantasy`
  - `monospace`

- `font_size`: The font size of you want to use for the text. The unit is logical pixels.
- `line_height`: The separation between two different lines in the wrapped text. The separation between two different paragraphs is `line_height * 2`
- `language`: The programming language to syntax highlight the text as. You must have the [Helix text editor](https://helix-editor.com/) somewhere on your system in order for this to work. It only depends on the runtime dir, which can be set as the `HELIX_RUNTIME` environment variable
